/* $Id: cmotion.c,v 1.13 2004/04/01 23:23:50 garbled Exp $ */
/*
    Genecys, A Multiplayer Online RPG

    Copyright (C) 2003 Tim Rightnour
    Copyright (C) 2003 Genecys Developer Team

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    The authors can be reached via e-mail at genecys-devel@lists.sourceforge.net
*/

#include <inttypes.h>
#if defined(__linux__)
#include "queue.h"
#else
#include <sys/queue.h>
#endif

#include <rm/rm.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <gtk/gtk.h>
#include <gdk/gdkx.h>

#include "timers.h"
#include "mappings.h"
#include "defines.h"
#include "utils.h"
#include "cobject.h"
#include "cnet.h"
#include "camera.h"
#include "cmotion.h"

extern cmap_t mapcache[9];
extern RMnode *mainchar;

#if 0
void move_self(RMpipe *p, RMnode *node, float dist)
{
        RMvertex3D *vert;
        RMmatrix n, old, model;
	client_t *obj;
	float mvdist;
	char buf[256];

	obj = (client_t *)rmNodeGetClientData(mainchar);
	if (!(obj->mvallow > 0.0)) {
	    req_movement();
	    return;
	}
	mvdist = calc_object_velocity(obj);
	if (mvdist > obj->mvallow)
	    mvdist = obj->mvallow;

	printf("mvallow:%f mvdist:%f\n", obj->mvallow, mvdist);

	obj->mvallow -= mvdist;

        rmMatrixIdentity(&n);
	n.m[0][3] = -1 * mvdist * dist;
	n.m[2][3] = -1 * mvdist * dist;

        if (rmNodeGetRotateMatrix(node, &old) == RM_WHACKED)
            rmMatrixIdentity(&old);
	rmMatrixInverse(&old, &old);
        rmMatrixMultiply(&old, &n, &old);
	/*rmPrintMatrix(&old);*/
        vert = malloc(sizeof(RMvertex3D));
        rmNodeGetTranslateVector(node, vert);
/*         printf("OLD x=%f y=%f z=%f\n", vert->x, vert->y, vert->z); */
        vert->x += old.m[0][3];
/*        vert->y += old.m[1][3];*/
        vert->z += old.m[2][3];
	vert->y = (float)groundheight_at_xz(mapcache[0].elevation,
            (double)vert->x, (double)vert->z, mapcache[0].height,
	    mapcache[0].width);
/* 	printf("gh: %f mx %f mz %f\n", groundheight_at_xz(mapcache[0].elevation, (double)vert->x/xscale, (double)vert->z/zscale, mapcache[0].height, mapcache[0].width), vert->x/xscale, vert->z/zscale); */

	rmNodeGetCompositeModelMatrix(node, &model);
	/*rmPrintMatrix(&model);*/

        moveCamera(node);
        rmNodeSetTranslateVector(node, vert);
/*         printf("NEW x=%f y=%f z=%f\n", vert->x, vert->y, vert->z); */
        
        free(vert);
	sprintf(buf, "mv id:%d cx:%f cy:%f cz:%f\n", obj->num,
		old.m[0][3], 0.0, old.m[2][3]);
	do_write(buf);
	if (!(obj->mvallow > 0.0))
	    req_movement(); /* ask for more, while we are here */
}
#endif 

void rotate_self(RMpipe *p, RMnode *node, float dir)
{
        RMmatrix m, old;
        double d,c,s;
	client_t *obj;
	char *buf;

        rmMatrixIdentity(&m);
        d = RM_DEGREES_TO_RADIANS(dir);
        c = cos(d);
        s = sin(d);
        m.m[0][0] = m.m[2][2] = c;
        m.m[0][2] = -s;
        m.m[2][0] = s;

        if (rmNodeGetRotateMatrix(node, &old) == RM_WHACKED)
            rmMatrixIdentity(&old);
        rmMatrixMultiply(&old, &m, &old);
        rmNodeSetRotateMatrix(node ,&old);

        moveCamera(node);
	/*printf("rotating by %f\n", dir);*/

	obj = (client_t *)rmNodeGetClientData(node);
	obj->facing.y = add_euler(obj->facing.y, dir);
	obj->direction.y = add_euler(obj->direction.y, dir);

	buf = malloc(sizeof(char)*40);
	sprintf(buf, "rot fy:%f dy:%f\r", obj->facing.y, obj->direction.y);
	do_write(buf);
}

void rotate_obj(RMpipe *p, RMnode *node, vertex_t dir, int type)
{
        RMmatrix m, old;
        double d,c,s;

        rmMatrixIdentity(&m);
	if (type == ROT_NORMAL)
	    d = RM_DEGREES_TO_RADIANS(dir.y);
	else
	    d = RM_DEGREES_TO_RADIANS(add_euler(dir.y, 135));
        c = cos(d);
        s = sin(d);
        m.m[0][0] = m.m[2][2] = c;
        m.m[0][2] = -s;
        m.m[2][0] = s;

	if (type == ROT_NORMAL) {
	    if (rmNodeGetRotateMatrix(node, &old) == RM_WHACKED)
		rmMatrixIdentity(&old);
	} else
	    rmMatrixIdentity(&old);

        rmMatrixMultiply(&old, &m, &old);
        rmNodeSetRotateMatrix(node ,&old);

        rmMatrixIdentity(&m);
        d = RM_DEGREES_TO_RADIANS(dir.x);
        c = cos(d);
        s = sin(d);
        m.m[1][1] = m.m[2][2] = c;
        m.m[2][1] = -s;
        m.m[1][2] = s;

        rmMatrixMultiply(&old, &m, &old);
        rmNodeSetRotateMatrix(node ,&old);

        rmMatrixIdentity(&m);
        d = RM_DEGREES_TO_RADIANS(dir.z);
        c = cos(d);
        s = sin(d);
        m.m[1][1] = m.m[0][0] = c;
        m.m[1][0] = -s;
        m.m[0][1] = s;

        rmMatrixMultiply(&old, &m, &old);
        rmNodeSetRotateMatrix(node ,&old);
}
