/* $Id: cutils.c,v 1.4 2004/03/24 10:14:09 xb49 Exp $ */
/*
    Genecys, A Multiplayer Online RPG

    Copyright (C) 2003 Tim Rightnour
    Copyright (C) 2003 Genecys Developer Team

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    The authors can be reached via e-mail at genecys-devel@lists.sourceforge.net
*/

#include <sys/param.h>
#include <sys/time.h>
#include <inttypes.h>
#if defined(__linux__)
#include "queue.h"
/*#define bool char*/
#else
#include <sys/queue.h>
#endif

#include <rm/rm.h>
#include <rm/rmaux.h>
#include <GL/gl.h>
#include <GL/glu.h>
#undef False
#undef True
#define bool enum Boolean
#include <cal3d/cal3d_wrapper.h>
#include <libxml/xmlmemory.h>
#include <libxml/parser.h>

#include "defines.h"
#include "timers.h"
#include "utils.h"
#include "xmlparse.h"
#include "cutils.h"

void quat_to_matrix(quat_t *quat, RMmatrix *m)
{
    float sqw = quat->w*quat->w;
    float sqx = quat->x*quat->x;
    float sqy = quat->y*quat->y;
    float sqz = quat->z*quat->z;
    float tmp1 = quat->x*quat->y;
    float tmp2 = quat->z*quat->w;

    m->m[0][0] =  sqx - sqy - sqz + sqw; // since sqw + sqx + sqy + sqz =1
    m->m[1][1] = -sqx + sqy - sqz + sqw;
    m->m[2][2] = -sqx - sqy + sqz + sqw;
    
    m->m[1][0] = 2.0 * (tmp1 + tmp2);
    m->m[0][1] = 2.0 * (tmp1 - tmp2);
    
    tmp1 = quat->x*quat->z;
    tmp2 = quat->y*quat->w;
    m->m[2][0] = 2.0 * (tmp1 - tmp2);
    m->m[0][2] = 2.0 * (tmp1 + tmp2);
    tmp1 = quat->y*quat->z;
    tmp2 = quat->x*quat->w;
    m->m[2][1] = 2.0 * (tmp1 + tmp2);
    m->m[1][2] = 2.0 * (tmp1 - tmp2);      
}

void prep_xmat(RMmatrix *m, float dir)
{
    double d,c,s;

    rmMatrixIdentity(m);
    d = RM_DEGREES_TO_RADIANS(dir);
    c = cos(d);
    s = sin(d);
    m->m[1][1] = c;
    m->m[1][2] = s;
    m->m[2][1] = -s;
    m->m[2][2] = c;
}

void prep_ymat(RMmatrix *m, float dir)
{
    double d,c,s;

    rmMatrixIdentity(m);
    d = RM_DEGREES_TO_RADIANS(dir);
    c = cos(d);
    s = sin(d);
    m->m[0][0] = c;
    m->m[2][2] = c;
    m->m[0][2] = -s;
    m->m[2][0] = s;
}

void prep_zmat(RMmatrix *m, float dir)
{
    double d,c,s;

    rmMatrixIdentity(m);
    d = RM_DEGREES_TO_RADIANS(dir);
    c = cos(d);
    s = sin(d);
    m->m[0][0] = c;
    m->m[0][1] = s;
    m->m[1][0] = -s;
    m->m[1][1] = c;
}
