/* $Id: cobject.h,v 1.16 2004/03/23 15:28:52 xb49 Exp $ */
#include "uid.h"
typedef struct _client_t {
    uniqid_t uid;            /* Unique ID */
    int nrof;           /* number of obj in pile */
    int state;          /* state of obj */
    char *name;         /* name */
    char *name_pl;      /* plural name */
    char *model;        /* filename of 3D model */
    vertex_t facing;    /* direction facing */
    vertex_t direction; /* direction moving */
    vertex_t coord;     /* coordinates */
    vertex_t scale;	/* scale of object */
    stats_t stats;      /* stats of object */
    float velocity;    /* how fast are we moving in direction? */
    /* things not provided by the genecys server, client side only */
    RMnode *node;	/* rmnode for this object */
    float mvallow;	/* move allowance */
    struct _genmodel_t *gmod;	/* gmodel instance */
    struct _anim_t *anim;	/* calmodel instance */
    GtkTreeIter iter;	/* GTK tree node for obj, if any */
    uniqid_t container;	/* obj id that contains me */
    TAILQ_ENTRY(_client_t) next;
} client_t;

/* XXX for now, the client has no tracking method for objects in an object's
   inventory, other than the player */

#define MAXSPEED	100

client_t *new_object(void);
client_t *find_obj_by_id(uniqid_t * id);
void model_object(client_t *obj, RMnode *attachnode);
void req_self_movement(float dir, int state);
void compute_fog(client_t *obj);
void add_main_char(uniqid_t * id);
void change_obj_state(client_t *obj, int newstate);
void change_player_state(int newstate);
void remove_obj(client_t *obj);
extern uniqid_t  player_id;
extern client_t * player_obj ;
