/* $Id: mappings.h,v 1.6 2004/03/31 05:27:50 garbled Exp $ */

/**
   \file mappings.h
   \brief Client map definitions
   \author Tim Rightnour
*/

/**
   \brief client map cache structure
*/
typedef struct _cmap_t {
    RMnode *mapnode;	    /**< \brief rmnode for this map (the floor node) */
    RMnode **tnodes;		/**< \brief texture subnodes */
    uint8_t **elevation;	/**< \brief elevation dataset */
    uint8_t **terrain;		/**< \brief terrain dataset */
    int width;			/**< \brief map width */
    int height;			/**< \brief map height */
    float basex, basey, basez;	/**< \brief xbase, elevation base, zbase */
} cmap_t;

void set_sky_condition(int curhour, int cloudlevel);
void load_sky_textures(void);
void cleanFloor(RMnode *addto, int m);
void addFloor(RMnode *addto, int m);
int GenNodeFrustumCullCallback(const RMnode *n, const RMstate *s);
void move_map(int from, int to);
void shift_maps(int dir);
