/* $Id: parser.h,v 1.9 2004/03/31 05:27:50 garbled Exp $ */

/**
   \file parser.h
   \brief Server command parsing definitions
   \author Tim Rightnour
*/

/* this should be identical to the one in server/include/text.h */
#define DATA_MOTD	1
#define DATA_NEWS	2
#define DATA_SAY	3
#define DATA_INFO	4

/* the commands understood by the client */

#define COMMAND_UR      	1
#define COMMAND_NUOB    	2
#define COMMAND_BBOX    	3
#define COMMAND_CHOB    	4
#define COMMAND_NOMV    	5
#define COMMAND_INV     	6
#define COMMAND_RMINV   	7
#define COMMAND_EQ      	8
#define COMMAND_UEQ     	9
#define COMMAND_RMOB    	10
#define COMMAND_EACT    	11
#define COMMAND_READY   	12
#define COMMAND_NOADPL  	13
#define COMMAND_TEXT    	14
#define COMMAND_MSRVDONE	15
#define COMMAND_SERVER		16
#define COMMAND_MAPELEV		17
#define COMMAND_MAPTERR		18
#define COMMAND_MAPSHIFT	19
#define COMMAND_MAPDELETE	20
#define COMMAND_SRVFULL		21
#define COMMAND_SRVD		22
#define COMMAND_MAX     	23 /* keep this last */

int parse_command_null(pargs_t *args, char *pos);
int parse_command_msrvdone(pargs_t *args, char *pos);
int parse_command_server(pargs_t *args, char *pos);
int parse_command_bbox(pargs_t *args, char *pos);
int parse_command_ur(pargs_t *args, char *pos);
int parse_command_nuob(pargs_t *args, char *pos);
int parse_command_chob(pargs_t *args, char *pos);
int parse_command_nomv(pargs_t *args, char *pos);
int parse_command_eact(pargs_t *args, char *pos);
int parse_command_inv(pargs_t *args, char *pos);
int parse_command_rminv(pargs_t *args, char *pos);
int parse_command_rmob(pargs_t *args, char *pos);
int parse_command_eq(pargs_t *args, char *pos);
int parse_command_ueq(pargs_t *args, char *pos);
int parse_command_text(pargs_t *args, char *pos);
int parse_command_mape(pargs_t *args, char *pos);
int parse_command_mapt(pargs_t *args, char *pos);
int parse_command_maps(pargs_t *args, char *pos);
int parse_command_mapd(pargs_t *args, char *pos);
int parse_command_srvfull(pargs_t *args, char *pos);
int parse_command_srvd(pargs_t *args, char *pos);
