/* $Id: skelanim.h,v 1.9 2003/12/03 16:37:47 garbled Exp $ */

typedef struct _attach_t {
    int attachpoint;
    int boneid;
    RMnode *node;
    float xrot, yrot, zrot;
    TAILQ_ENTRY(_attach_t) next;
} attach_t;

typedef struct _calcore_t {
    struct CalCoreModel *coremodel;
    char *filename;
    char *path;
    char *tpath;
    int *animations;
    float scale;
    float tiltangle;
    float twistangle;
    RMvertex3D bmax, bmin;
    TAILQ_ENTRY(_calcore_t) next;
    TAILQ_HEAD(, _attach_t) attachments;
} calcore_t;

typedef struct _anim_t {
    uint32_t lasttick;
    bool paused;
    calcore_t *coremodel;
    struct CalModel *calmodel;
    int curanimid;
    int prevanimid;
    float animtimeleft;
    float blendtime;
    int vertexcount;
    int facecount;
    TAILQ_ENTRY(_anim_t) next;
    RMnode *node; /* backpointer to the node */
    /* also need to track object ID, and pointer to object structure */
} anim_t;

int find_anim_for_state(calcore_t *corem, int state);
void perform_action(client_t *obj, int action);
void prerender_calmodels(void);
void rmCal3D OGLPRIMPARMLIST();
anim_t *create_calmodel(char *name);
void delete_calmodel(anim_t *an);
