/* $Id: textures.h,v 1.4 2004/03/31 03:45:45 garbled Exp $ */

#ifndef _TEXTURES_H_
#define _TEXTURES_H_

/**
   \brief ground texture map data
*/

typedef struct _tmap_t {
    int width;                  /**< \brief weidth of texture */
    int height;                 /**< \brief height of texture */
    RMtexture *texture;         /**< \brief texture data */
    char *path;                 /**< \brief path to texture */
    int tformat;		/**< \brief texture format TFORM_* */
    char *name;			/**< \brief texture name */
} tmap_t;

/**
   \brief sky condition texture and color data
*/

typedef struct _skycond_t {
    int width;		/**< \brief width of image */
    int height;		/**< \brief height of image */
    RMimage *image;	/**< \brief image data */
    char *path;		/**< \brief path to image file */
    int tformat;	/**< \brief image format TFORM_* */
    RMcolor4D sky;	/**< \brief sky bg color */
    RMcolor4D fog;	/**< \brief fog color */
} skycond_t;

/**
   \brief sky map data
*/

typedef struct _skymap_t {
    skycond_t *day;	/**< \brief daytime conditions */
    skycond_t *night;	/**< \brief nighttime conditions */
    skycond_t *dusk;	/**< \brief dusk conditions */
    skycond_t *dawn;	/**< \brief dawn conditions */
} skymap_t;


#define TFORM_JPEG	1	/**< \brief Texture is JPG (RGB) */
#define TFORM_PNG	2	/**< \brief Texture is PNG (RGBA) */

tmap_t *parsegtextures(char *filename, char *path);
skymap_t *parse_skymaps(char *filename, char *path);

#endif /* _TEXTURES_H_ */
