/* $Id: language.h,v 1.2 2004/03/19 07:36:50 garbled Exp $ */

#ifndef _LANGUAGE_H_
#define _LANGUAGE_H_

/**
   \file language.h
   \brief Language translation definitions
   \author Tim Rightnour
*/

/* :%s/.*{ *"\(.*\)", *"\(.*\)" *},/<syl eng="\1">\2<\/syl>/ */

/** \brief the language structure */
typedef struct _lang_t {
    char *name; 	/**< \brief Name of this language */
    int id;		/**< \brief ID# for this language */
    int syls;		/**< \brief num of sylables */
    char **orig;       	/**< \brief sylables to translate from */
    char **lang;	/**< \brief what to translate them into */
    TAILQ_ENTRY(_lang_t) next; /**< \brief next language */
} lang_t;

/** \brief malloc sylables in chunks of X */
#define SYL_MALLOC_CHUNK 100

void parse_language(char *path, lang_t *lang);
void parse_languages(char *path, char *filename);
char *translate_string(char *input, int langid, int knowledge);

#endif /* _LANGUAGE_H_ */
