/* $Id: metaserv.h,v 1.2 2004/03/16 04:55:10 garbled Exp $ */

#ifndef _METASERV_H_
#define _METASERV_H_

/**
   \file metaserv.h
   \author Tim Rightnour
   \brief Metaserver data definitions
*/

/**
   \brief Metaserver record structure
*/

typedef struct _mservdata {
    char *id;		/**< \brief Identifier */
    char *name;		/**< \brief Server name */
    char *ip;		/**< \brief Server IPaddr */
    int port;		/**< \brief server portnum */
    char *desc;		/**< \brief Description */
    char *mapinfo;	/**< \brief Map description */
    char *hostname;	/**< \brief hostname */
    char *version;	/**< \brief version server runs */
    char *webpage;	/**< \brief server webpage */
    char *ownername;	/**< \brief Owner's name */
    char *owneremail;	/**< \brief Owner's email address */
    time_t lastupdate;	/**< \brief last time we recieved an update */
    time_t firstupdate;	/**< \brief first update we ever got */
    int numusers;	/**< \brief number of users on ~now */
    int userhwm;	/**< \brief most users ever on */
    int maxusers;	/**< \brief maximum users allowed */
    int preferip;	/**< \brief server prefers IPADDR over hostname */
    TAILQ_ENTRY(_mservdata) next;	/**< \brief next server in list */
} mservdata_t;

#endif /* _METASERV_H_ */
