/* $Id: quadric.h,v 1.2 2004/03/16 06:57:40 garbled Exp $ */

#ifndef _QUADRIC_H_
#define _QUADRIC_H_

/**
   \file quadric.h
   \author Tim Rightnour
   \brief Quadric definitions
*/

/**
   \brief A quadric
*/
typedef struct _quadric {
    float m_aa, m_ab, m_ac, m_ad;
    float       m_bb, m_bc, m_bd;
    float             m_cc, m_cd;
    float                   m_dd;
    float m_area;
} quadric_t;

void add_quadric(quadric_t *a, quadric_t *b);
void set_quadric(quadric_t *a, quadric_t *b);
float eval_quadric(float x, float y, float z, quadric_t *a);
void scale_quadric(float factor, quadric_t *a);
void set_quadric_plane(float nx, float ny, float nz, float d, float area,
        quadric_t *a);
void set_quadric_edge(float x1, float y1, float z1, float x2, float y2,
        float z2, float nx, float ny, float nz, quadric_t *a);
#endif /* _QUADRIC_H_ */
