/* $Id: xmlparse.h,v 1.9 2004/03/31 03:45:46 garbled Exp $ */
/*
    Genecys, A Multiplayer Online RPG

    Copyright (C) 2003 Tim Rightnour
    Copyright (C) 2003 Genecys Developer Team

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    The authors can be reached via e-mail at genecys-devel@lists.sourceforge.net
*/
#ifndef __xmlparse_h__
#define __xmlparse_h__

/**
   \file xmlparse.h
   \author Tim Rightnour
   \brief XML parsing definitions
*/

#include "uid.h"

void parselong(xmlDocPtr doc, xmlNodePtr cur, long *data);
void parseint(xmlDocPtr doc, xmlNodePtr cur, int *data);
void parsetriint(xmlDocPtr doc, xmlNodePtr cur, int *x, int *y, int *z);
void parsequadint(xmlDocPtr doc, xmlNodePtr cur,
		  int *w, int *x, int *y, int *z);
void parsestat(xmlDocPtr doc, xmlNodePtr cur, stat_t *stat);
void parsestring(xmlDocPtr doc, xmlNodePtr cur, char **string);
void parsevector(xmlDocPtr doc, xmlNodePtr cur, vertex_t *vector);
void parsetrifloat(xmlDocPtr doc, xmlNodePtr cur, float *x, float *y, float *z);
void parsetridouble(xmlDocPtr doc, xmlNodePtr cur, double *x, double *y,
		    double *z);
void parsefloat(xmlDocPtr doc, xmlNodePtr cur, float *data);
void parsedouble(xmlDocPtr doc, xmlNodePtr cur, double *data);
/** @brief parsing an uid **/
void parseuid(xmlDocPtr doc, xmlNodePtr cur, uniqid_t *data);


/*writers*/
void write_double(xmlNodePtr node, char *elm, double d);
void write_float(xmlNodePtr node, char *elm, float f);
void write_long(xmlNodePtr node, char *elm, long l);
void write_int(xmlNodePtr node, char *elm, int i);
void write_triint(xmlNodePtr node, char *elm, int i, int j, int k);
void write_quadint(xmlNodePtr node, char *elm, int i, int j, int k, int l);
void write_string(xmlNodePtr node, char *elm, char *string);
void write_trifloat(xmlNodePtr node, char *elm, float x, float y, float z);
/** @brief write an uid **/
void write_uid(xmlNodePtr node, char *elm, uniqid_t *data);


#endif
