/* $Id: lodder.h,v 1.3 2004/01/19 19:17:57 garbled Exp $ */
#define M_TRI_BLOCK     1
#define M_TRI_STRIP     2

typedef struct _facen {
	int *nei;
	int num;
} facen_t;

typedef struct _Lvertex {
	int lodid;
	int collapseid;
	quadric_t quadrad;
	float error;
	int faceCollapseCount;
	float x,y,z;
	float nx, ny, nz;
	float tu,tv;
	int collapsed;
	int frozen;
	facen_t *faceid;
	facen_t *neighbor;
} Lvertex_t;

typedef struct _Lface {
	int lodid;
	int vertexid[3];
	quadric_t quadrad;
} Lface_t;

typedef struct _Ltriangle {
	Lface_t *faces;
	Lface_t *trufaces;
	int numfaces;
	int nextfacelodid;
	int lodcount;
	char *name;
	int matnum;
        int optmesh;
} Ltriangle_t;

typedef struct _Lmat {
	char *name;
	char *image;
	float ambient[4];
	float diffuse[4];
	float specular[4];
	float shine;
} Lmat_t;

typedef struct _Lmesh {
	Ltriangle_t *triangles;
	int numtriangles;
	Lvertex_t *verts;
	int numverts;
	int nextvertexlodid;
	int nobox;
} Lmesh_t;

typedef struct _Lmodel {
	Lmesh_t *meshes;
	int nummeshes;
	Lmat_t *mats;
	int nummats;
	char *name;
	char *id;
	char *modeledby;
	char *paintedby;
        vertex_t bmin, bmax, cog, center;
        float volume;
} Lmodel_t;
