/* $Id: mnetwork.h,v 1.1 2004/02/18 20:10:14 garbled Exp $ */

typedef struct _descriptor_data_t {
    int	descriptor;
    char *in_buf;
    char *out_buf;
    char host[50];
    char ipaddr[16];
    time_t idle;
    TAILQ_ENTRY(_descriptor_data_t) next;
} descriptor_data_t;

#define BIND_PORT	5502	/* TCP port to bind to. NOTE: To bind to
				 * ports that are < 1024, you usually need
				 * superuser permission on that system */
#define USEC_TIMEOUT	250000	/* Timeout between polls in ms */
#define IDLE_TIMEOUT	30	/* Timeout before disconnecting an idle
				 * connection in seconds. (0=No Timeout) */
#define NO_NAGLE		/* Socket option TCP_NODELAY. Read comments
				 * in init_socket() for details. */
#define NONBLOCK		/* Turns on non-blocking on descriptors. Read
				 * comments in init_desc() for details. */
#define USE_INET_NTOA		/* This should only be undefined if you have
				 * problems with inet_ntoa() */

void *network_loop(void *nada);
void init_network(void);
void do_write(descriptor_data_t *d, char *buf);
void close_desc(int d);
void free_desc(descriptor_data_t *d);
