/* prototypes for event functions */
int event_say(event_t*event);
int event_who(event_t*event);
int metaserver_update(event_t*event);
int npc_ehandler(event_t*event);
int npc_life_handler(event_t*event);
int obj_drop_obj(event_t*event);
int obj_eact(event_t*event);
int obj_get_obj(event_t*event);
int obj_removed_from_map(event_t*event);
int obj_unwear_obj(event_t*event);
int obj_unwore_obj(event_t*event);
int obj_wear_obj(event_t*event);
int obj_wore_obj(event_t*event);
int object_teach_players_self(event_t*event);
int player_check_border_distance(event_t*event);
int player_enter_mapg(event_t*event);
int player_find_surrounds(event_t*event);
int player_modpl(event_t*event);
int player_perc_surrounds(event_t*event);
int player_rotate(event_t*event);
int player_update_all_motion(event_t*event);
int process_outgoing_queue(event_t*event);
int remove_player_game(event_t*event);
int save_persistent_data(event_t*event);
int send_motd(event_t*event);
int tell_player_surr_changes(event_t*event);
int update_all_maps_object_motion(event_t*event);

/** \brief event function name->function mapping */
funcrec_t event_func_map[] =
{
    { "aaa_empty_func_handler", empty_func_handler,{0} },
    {"event_say",event_say,{0x20} /* DEL_NOT_IN_MAPG */},
    {"event_who",event_who,{0x40} /* INITIATOR */},
    {"metaserver_update",metaserver_update,{0x0}},
    {"npc_ehandler",npc_ehandler,{0x20} /* DEL_NOT_IN_MAPG */},
    {"npc_life_handler",npc_life_handler,{0x0}},
    {"obj_drop_obj",obj_drop_obj,{0x20} /* DEL_NOT_IN_MAPG */},
    {"obj_eact",obj_eact,{0x20} /* DEL_NOT_IN_MAPG */},
    {"obj_get_obj",obj_get_obj,{0x20} /* DEL_NOT_IN_MAPG */},
    {"obj_removed_from_map",obj_removed_from_map,{0x20} /* DEL_NOT_IN_MAPG */},
    {"obj_unwear_obj",obj_unwear_obj,{0x20} /* DEL_NOT_IN_MAPG */},
    {"obj_unwore_obj",obj_unwore_obj,{0x20} /* DEL_NOT_IN_MAPG */},
    {"obj_wear_obj",obj_wear_obj,{0x20} /* DEL_NOT_IN_MAPG */},
    {"obj_wore_obj",obj_wore_obj,{0x20} /* DEL_NOT_IN_MAPG */},
    {"object_teach_players_self",object_teach_players_self,{0x20} /* DEL_NOT_IN_MAPG */},
    {"player_check_border_distance",player_check_border_distance,{0x22} /* NOSAVE|DEL_NOT_IN_MAPG */},
    {"player_enter_mapg",player_enter_mapg,{0x40} /* INITIATOR */},
    {"player_find_surrounds",player_find_surrounds,{0x20} /* DEL_NOT_IN_MAPG */},
    {"player_modpl",player_modpl,{0x20} /* DEL_NOT_IN_MAPG */},
    {"player_perc_surrounds",player_perc_surrounds,{0x22} /* NOSAVE|DEL_NOT_IN_MAPG */},
    {"player_rotate",player_rotate,{0x20} /* DEL_NOT_IN_MAPG */},
    {"player_update_all_motion",player_update_all_motion,{0x0}},
    {"process_outgoing_queue",process_outgoing_queue,{0x0}},
    {"remove_player_game",remove_player_game,{0x20} /* DEL_NOT_IN_MAPG */},
    {"save_persistent_data",save_persistent_data,{0x0}},
    {"send_motd",send_motd,{0x40} /* INITIATOR */},
    {"tell_player_surr_changes",tell_player_surr_changes,{0x2} /* NOSAVE */},
    {"update_all_maps_object_motion",update_all_maps_object_motion,{0x0}},
    { (char *)NULL, (int (*)(event_t *))NULL,{0}},
};

