/* $Id: collision.h,v 1.8 2004/03/30 06:45:55 garbled Exp $ */

#ifndef _COLLISION_H_
#define _COLLISION_H_

/**
   \file collision.h
   \brief Collision defines
   \author Tim Rightnour
*/

#include "defines.h"
#include "map.h"
#include "object.h"

#define COLL_NORMAL	0	/**< \brief Normal collision */
#define COLL_COUNT	1	/**< \brief Counted collision */
#define COLL_MARKTARGET	2	/**< \brief Target marking collision */
#define COLL_UNCOLLIDE	3	/**< \brief uncollide collision */

void collide2(void *client_data, DtObjectRef obj1, DtObjectRef obj2,
	      const DtCollData *coll_data);
void collide_count(void *client_data, DtObjectRef obj1, DtObjectRef obj2,
	      const DtCollData *coll_data);
void collide_marktarget(void *client_data, DtObjectRef obj1, DtObjectRef obj2,
	      const DtCollData *coll_data);
void collide_uncollide(void *client_data, DtObjectRef obj1, DtObjectRef obj2,
	      const DtCollData *coll_data);
object_t *create_finder_sphere(struct _player_t *center, float radius);
object_t *create_collision_sphere(vertex_t coord, float radius,
				  maphead_t *maph, int colltype);
void remove_collision_obj(object_t *obj);
int perform_collision_test(object_t *obj, vertex_t coord);

#endif /* _COLLISION_H_ */
