/* $Id: commands.h,v 1.12 2004/03/18 03:59:36 garbled Exp $ */
/*
    Genecys, A Multiplayer Online RPG

    Copyright (C) 2003 Tim Rightnour
    Copyright (C) 2003 Genecys Developer Team

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    The authors can be reached via e-mail at genecys-devel@lists.sourceforge.net
*/
#ifndef _COMMANDS_H_
#define _COMMANDS_H_

/**
   \file commands.h
   \brief Command defines
   \author Tim Rightnour
*/

#include "defines.h"
#include "object.h"
#include "network.h"
#include "netparser.h"

/** \brief Function to call to process a command */
typedef int (*command_func_t)(object_t *obj, pargs_t *args);

/** \brief The command structure */
typedef struct _commands_t {
    char *name;			/**< \brief command word */
    command_func_t func;	/**< \brief function to call */
    int queue;			/**< \brief queue priority */
    /* perhaps need some kind of timer? */
} commands_t;

/* from commands.c */
void init_commands(void);
int parsed_command(struct _descriptor_data_t *d, char *command, pargs_t *args);
object_t *parse_single_obj_param(pargs_t *args);
/* cmd_obj.c */
int command_drop(object_t *obj, pargs_t *args);
int command_get(object_t *obj, pargs_t *args);
int command_wield(object_t *obj, pargs_t *args);
int command_unwear(object_t *obj, pargs_t *args);
int obj_get_obj(struct _event_t *event);
int obj_drop_obj(struct _event_t *event);
int obj_wear_obj(struct _event_t *event);
int obj_unwear_obj(struct _event_t *event);
/* cmd_emote.c */
int command_wave(object_t *obj, pargs_t *args);
int command_who(object_t *obj, pargs_t *args);
int command_say(object_t *obj, pargs_t *args);

#endif /* _COMMANDS_H_ */
