/* $Id: models.h,v 1.10 2004/03/11 04:06:46 garbled Exp $ */

#ifndef _MODELS_H_
#define _MODELS_H

/**
   \file models.h
   \brief Model definitions
   \author Tim Rightnour
*/

#include "defines.h"
#include "object.h"

/**
   \brief Collision shape data for a model
*/
typedef struct _solid_t {
    char *model;	/**< \brief model name */
    int refcount;	/**< \brief reference count */
    DtShapeRef shape;	/**< \brief SOLID shape */
    TAILQ_ENTRY(_solid_t) next; /**< \brief next in list */
} solid_t;

#define M_TRI_BLOCK	1	/**< \brief A block of triangles */
#define M_TRI_STRIP	2	/**< \brief A triangle strip */

#define TWO_PI 6.28318530717958623200 	/**< \brief Two times PI */

void parse_calmodel(char *filename, object_t *obj);
void parse_genmodel_boxonly(char *filename, object_t *obj);
void parse_genmodel(char *filename, object_t *obj);

#endif /* _MODELS_H_ */
