/* $Id: ninterface.h,v 1.22 2004/03/31 05:27:50 garbled Exp $ */

#ifndef _NINTERFACE_H_
#define _NINTERFACE_H_
#include "uid.h"
/**
   \file ninterface.h
   \brief Network parsing interface
   \author Tim Rightnour
*/

/* parser commands */

#define COMMAND_ADPL   	1	/**< \brief Add a player */
#define COMMAND_MODPL  	2	/**< \brief Modify a player */
#define COMMAND_ROT    	3	/**< \brief Rotate a player */
#define COMMAND_READY  	4	/**< \brief do nothing */
#define COMMAND_MAX	5	/**< \brief last command */

/* parsers */
void parse_command_null(descriptor_data_t *d, pargs_t *pargs);
void parse_command_adpl(descriptor_data_t *d, pargs_t *pargs);
void parse_command_modpl(descriptor_data_t *d, pargs_t *args);
void parse_command_rot(descriptor_data_t *d, pargs_t *args);

/* tellers */
void tell_eact(player_t *pl, object_t *obj, int action);
void tell_inv_obj(player_t *pl, object_t *obj, object_t *cont, int bucket);
void tell_rminv_obj(player_t *pl, object_t *obj, object_t *cont, int bucket);
void tell_equip_obj(player_t *pl, object_t *obj, object_t *eq,
		    int slot, int draw);
void tell_unequip_obj(player_t *pl, object_t *obj, object_t *eq, int draw);
void tell_new_map(player_t *pl, int mapnum);
void tell_new_obj(player_t *pl, object_t *obj, int extended, int draw);
void tell_mapshift(player_t *pl, maphead_t *newmap);
void tell_moveok(player_t *pl, int moveok, double dist);
void tell_rmobj(player_t *pl, object_t *obj);
void tell_rmobjbyid(player_t *pl, uniqid_t *id);
void tell_text(player_t *pl, char *data, int datatype, object_t *from);
void say_text(player_t *pl, char *data, object_t *from, int volume);
void tell_servdefs(player_t *pl);

#endif /* _NINTERFACE_H_ */
