/* $Id: outnet.h,v 1.5 2004/04/02 02:39:00 garbled Exp $ */

#ifndef _OUTNET_H_
#define _OUTNET_H_

/**
   \file outnet.c
   \brief Outgoing network definitions
   \author Tim Rightnour
*/

/**
   \brief An outgoing connection socket
*/

typedef struct _servout {
    char *in_buf;       /**< \brief Input buffer */
    char *out_buf;      /**< \brief Output buffer */
    int socket;         /**< \brief main socket */
    pthread_mutex_t mutex; /**< \brief mutex protecting this connection */
} servout_t;

#define OUTCOMMAND_MAX	1

#include "netparser.h"

int process_outgoing_queue(event_t *event);
void parse_outcommand_null(servout_t *out, pargs_t *args);
servout_t *new_outgoing_connection(char *host, int port);
void do_write_out(servout_t *out, char *buf);
int outgoing_networker(servout_t *out);

#endif /* _OUTNET_H_ */
