/* $Id: physics.h,v 1.8 2004/03/30 06:45:55 garbled Exp $ */

#ifndef _PHYSICS_H_
#define _PHYSICS_H_

/**
   \file physics.h
   \brief Physics definitions
   \author Tim Rightnour
*/

#include "defines.h"
#include "object.h"

#define GRAVITY -9.8*POINTS_PER_METER  /**< \brief accel due to gravity */
/** \brief the basic coef of fricition, when no other is used */
#define FRICTION_COEF 0.7
#define ROLL_FRICTION_COEF 0.02 /**< \brief friction coef of a rolling obj */
#define DRAG_COEF 0.1	/**< \brief drag coefficent */
#define AIR_DENSE 1.225 /**< \brief avg density of air in kg/cubic meter */
/* Acceleration (m/sec^2)= 9.67 m/sec^2)* sin(0 ) */

float calc_obj_velocity(object_t *obj);
float calc_obj_trajectory(object_t *obj);
int attempt_move_obj(object_t *obj);

#endif /* _PHYSICS_H_ */
