/* $Id: servdata.h,v 1.4 2004/03/11 12:31:19 xb49 Exp $ */

#ifndef _SERVDATA_H_
#define _SERVDATA_H_
#include "uid.h"
/**
   \file servdata.h
   \brief Server data definitions
   \author Tim Rightnour

   two kinds of data are kept by the server.  Data that is kept and saved
   across boots, and data that is regenerated on a per-boot basis.
   each has it's own struct.
*/

/**
   \brief Server persistent data
*/

typedef struct _persist_data_t {
    unsigned long todtick;	/**< \brief time of day */
    int userhwm;		/**< \brief most users ever online at once */
	 uniqid_t uid_seed; /**< \brief seed for uniq id */
} persist_data_t;

/**
   \brief Non-persistent server data
*/

typedef struct _npersist_data_t {
    unsigned long objectcount;	/**< \brief current object counter */
    unsigned long mapcount;	/**< \brief current map counter */
    unsigned long pticks;	/**< \brief ticks */
    int maxdesc;		/**< \brief maximum number of desc available */
    int mainsocket;		/**< \brief main socket we listen on */
    int avail_descs;		/**< \brief available descriptors */
    int numusers;		/**< \brief number of users online now */
} npersist_data_t;

/* from loader.c */
void write_persist(void);

#endif /* _SERVDATA_H_ */
