/* $Id: settings.h,v 1.7 2004/03/18 04:49:19 garbled Exp $ */

#ifndef _SETTINGS_H_
#define _SETTINGS_H_

/**
   \file settings.h
   \brief Server settings
   \author Tim Rightnour
*/

/**
   \brief Server settings
*/
typedef struct _settings_t {
    char *archdir;	/**< \brief path to the arch directory */
    char *etcdir;	/**< \brief path to the etc directory */
    char *texdir;	/**< \brief path to the textures directory */
    char *mapdir;	/**< \brief path to the maps directory */
    char *vardir;	/**< \brief path to the var directory */
    int bindport;	/**< \brief port we listen on */
    int mservport;	/**< \brief port the metaserver listens on */
    char *mservhost;	/**< \brief hostname of our metaserver */
    int mservfreq;	/**< \brief how many hours between metaserver updates*/
    char *name;		/**< \brief the name of this server */
    char *desc;		/**< \brief A description of this server */
    char *version;	/**< \brief version the server is running */
    char *hostname;	/**< \brief the hostname of this server */
    char *webpage;	/**< \brief webpage about this server */
    char *ownername;	/**< \brief server owner's name */
    char *owneremail;	/**< \brief server owner's email address */
    char *mapinfo;	/**< \brief info about this server's maps */
    int maxusers;	/**< \brief maximum users this server allows online */
    int preferip;	/**< \brief do we prefer to be listed by our IP? */
} settings_t;

#endif /* _SETTINGS_H_ */
