/* $Id: tod.h,v 1.6 2004/03/11 07:21:03 garbled Exp $ */

#ifndef _TOD_H_
#define _TOD_H_

/**
   \file tod.h
   \brief Definitions for the time of day
   \author Tim Rightnour
*/

#define USECS_PER_CLOCK		10000	/**< \brief length of a ptick */
#define PTICKS_PER_CLOCK        600	/**< \brief pticks per hour */

#define PTICKS_PER_SPEED       	10	/**< \brief pticks per player speed */
#define TIMESLICE		0.1	/**< \brief timeslice for obj motion */
#define MAXSPEED		100    /**< \brief fastest speed obj can have*/

/* game time */
#define HOURS_PER_DAY           28	/**< \brief hours per day */
#define DAYS_PER_WEEK           7	/**< \brief days in a week */
#define WEEKS_PER_MONTH         5	/**< \brief weeks in a month */
#define MONTHS_PER_YEAR         8	/**< \brief months in a year */

/* convenience */
#define WEEKS_PER_YEAR          (WEEKS_PER_MONTH*MONTHS_PER_YEAR)
#define DAYS_PER_MONTH          (DAYS_PER_WEEK*WEEKS_PER_MONTH)
#define DAYS_PER_YEAR           (DAYS_PER_MONTH*MONTHS_PER_YEAR)
#define HOURS_PER_WEEK          (HOURS_PER_DAY*DAYS_PER_WEEK)
#define HOURS_PER_MONTH         (HOURS_PER_WEEK*WEEKS_PER_MONTH)
#define HOURS_PER_YEAR          (HOURS_PER_MONTH*MONTHS_PER_YEAR)

#define LUNAR_DAYS              DAYS_PER_MONTH	/**< \brief lunar period */

/**
   \brief The time of day structure
*/

typedef struct _timeofday_t {
    int year;		/**< \brief current year */
    int month;		/**< \brief current month */
    int day;		/**< \brief current day */
    int dayofweek;	/**< \brief current day of the week */
    int hour;		/**< \brief current hour */
    int minute;		/**< \brief current minute */
    int weekofmonth;	/**< \brief current week in the month */
    int season;		/**< \brief current season */
} timeofday_t;

#endif /* _TOD_H_ */
