/* $Id: d_queue.c,v 1.2 2004/03/18 06:50:02 kstenger Exp $ */
/*
    Genecys, A Multiplayer Online RPG

    Copyright (C) 2003 Karla Stenger
    Copyright (C) 2003 Genecys Developer Team

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    The authors can be reached via e-mail at genecys-devel@lists.sourceforge.net
*/

#include <stdio.h>
#include <stdlib.h>
#include <inttypes.h>

#include "d_queue.h"
#include "defines.h"
#include "utils.h"

struct dot  *d_new_dot(int x, int y, int dir){
    
    struct dot *d = safer_malloc(sizeof(struct dot));
    
    d->x    = x;
    d->y    = y;
    d->dir  = dir;
    d->next = NULL;
    
    return d;
};

struct dots *d_new_queue(void){
    
    struct dots *q = safer_malloc(sizeof(struct dots));
    
    q->fst=NULL;
    q->lst=NULL;
    
    return q;
};

void d_queue_dot(struct dot *d, struct dots *q){
    
    struct dot *t= d_new_dot(d->x,d->y,d->dir);
    
    if (q->lst) q->lst->next = t;
    else	q->fst = t;
    
    q->lst = t;
};

struct dot  *d_dequeue_dot(struct dots *q){
    struct dot *d = q->fst;
    if (d) {
	if (!(q->fst = q->fst->next)) 
	    q->lst=NULL; /* in case we just removed the last element */
	
	d->next=NULL;
    }
    return d;
};
