/* $Id: plates.h,v 1.2 2004/03/18 07:59:12 kstenger Exp $ */

#ifndef PLATES_H
#define PLATES_H

/* The plates in use are stored in this data structure.  Dx,dy are the
   values to move by THIS STEP ONLY; odx,ody are the permanent move
   values; rx,ry are the remainder x and y values used by newdxy() to
   determine dx,dy; age is the age of the plate, in steps; area is the
   area of the plate, in squares; id is the value in the m array which
   corresponds to this plate; next is a pointer to the next occupied
   element of the plate array. */


void plates_alloc(void);
void plates_free(void);

int plate_add (void);
void plate_remove (int n);
struct plate *get_plate(int n);


struct plate { 
    int dx, dy, odx, ody, rx, ry;
    int age, area, id;
    struct plate *next;
    int in_use;
};

struct plates {
    struct plate *first;
    struct plate *last;
} p;

#endif
