
import string,sys,re,os.path
incfile = 'include/event.h'
tblfile = 'eventtable.txt'
outfile = 'eventtable.h'
FlagSize = 0 # nuber of int in flag






def CheckFile(fn) :
	if not os.path.exists(fn) :
		print "File not found '%s'"%fn
		sys.exit(1)
def GetFlag(s) :
	s = s.strip()
	if s not in Flags :
		print 'Bad Flag \'%s\''%s
		sys.exit(1)
	return s

#get all flags
CheckFile(incfile)
Flags = {}
for n,v in re.findall(r'#define\s+EVFLAG_(\S+)\s+(\d+)',open(incfile).read()) :
	if n == 'SIZE' : FlagSize = int(v)
	else :Flags[n] = int(v)
if not FlagSize :
	print "EVFLAG_SIZE is missing in",incfile
	sys.exit(1)
	
#read the input file
CheckFile(tblfile)
Events = []
for i in open(tblfile) :
	l = i.strip()
	# ignore empty line and comment
	if not l or l [:1] == '#' : continue
	d =  l.split(None,1)
	name = d[0]
	flags = []
	if len(d) >= 2 : 
		for f in d[1].split(',') :
			flags.append(GetFlag(f))
	Events.append((name,flags))
Events.sort()

#write output
NoFlags = '{0'+(FlagSize-1)*',0'+'}'
try :
	w = open(outfile,"w").write
except :
	print "Can't create out file '%s'"%outfile

w("/* prototypes for event functions */\n")
for i,j in Events :
	w("int %s(event_t*event);\n"%i)
w("""\n/** \\brief event function name->function mapping */
funcrec_t event_func_map[] =
{
    { "aaa_empty_func_handler", empty_func_handler,%s },
"""%NoFlags)
for n,f in Events :
	w('    {"%s",%s,{'%(n,n))
	flv = FlagSize * [0]
	for fn in f :
		v = Flags[fn]
		flv [v/32] |= 1 << (v%32)
	w(string.join(map((lambda x:"0x%x"%x),flv),','))
	w('}')
	if f : w(" /* "+string.join(f,'|')+' */')
	w('},\n')
	pass

w("""    { (char *)NULL, (int (*)(event_t *))NULL,%s},
};

"""%NoFlags)
