#!/bin/sh
# $Id: buildgendata.sh,v 1.5 2004/04/03 15:25:43 garbled Exp $

if [ -z "$1" ]; then
  echo "Need target argument"
  exit 1
fi
echo "Creating Directories"
for i in `find data -type d | grep -v CVS | sed -e 's/data\/*//' | grep -v '^$'`
do
  mkdir -p $1/$i
done

echo "Compressing and copying Genecys Models"
for i in `find data -type f -name \*.xgm | sed -e 's/data\/*//'`
do
  DN=`dirname $i`
  BN=`basename $i`
  gzip -9c data/$i > $1/$DN/$BN
done

echo "Compressing and copying Cal Model Descriptions"
for i in `find data -type f -name \*.xcm | sed -e 's/data\/*//'`
do
  DN=`dirname $i`
  BN=`basename $i`
  cat data/$i | sed -e 's/\.x/.c/' | gzip -9c - > $1/$DN/$BN
done

echo "Converting Cal Models (this may take awhile)"
for i in `find data -type f -name \*.x\?f | sed -e 's/data\/*//'`
do
  DN=`dirname $i`
  SUF=`echo $i | sed -e 's/.*\.//'`
  SUF2=`echo $SUF | sed -e 's/x/c/'`
  BN=`basename $i $SUF`
  cal3d_converter data/$i $1/$DN/$BN$SUF2
done

echo "Copying JPEGs"
for i in `find data -type f -name \*.jpg | sed -e 's/data\/*//'`
do
  DN=`dirname $i`
  BN=`basename $i`
  cp data/$i $1/$i
done

echo "Copying PNGs"
for i in `find data -type f -name \*.png | sed -e 's/data\/*//'`
do
  DN=`dirname $i`
  BN=`basename $i`
  cp data/$i $1/$i
done

echo "Copying other stuff"
cp data/etc/* $1/etc
cp data/map/* $1/map
cp data/libdata/* $1/libdata
mkdir $1/var

# build the archetypes file
tools/buildarches.sh $1
