#!/usr/pkg/bin/perl

open(FILE, $ARGV[0]);

$dir = $ARGV[0];
$dir =~ s/\.3d//;

$cmesh=-1;
while(<FILE>) {
	if (/^ *$/) {next;}
	if (/ArkModel/) {next;}
	if (/Materials/) {$materials=1; $cmat=0; next;}
	if (/SubModels/) {$submodels=1; next;}
	if (/Mesh/) {$mesh=1; next;}
	if (/Triangle/) {
		$triangle=1;
		$cmesh++;
		if (/strip/) { $meshtype[$cmesh]=1; $ttype=1; $cstrip=0; }
		if (/block/) { $meshtype[$cmesh]=2; $ttype=2; $cblock=0; }
		next;
	}
	if ($submodels == 1 && /SubModel/) {$submodel=1; next;}
	if ($submodel == 1 && /VertexBuffer/) {$vertex=1; $cvertex=0; next;}
	if (/{/) {next;}
	if (/}/) {
		if ($materials) { $materials=0; }
		if ($submodels && $submodel && $mesh && $triangle) {
			$triangle=0;
			next;
		}
		if ($submodels && $submodel && $mesh) { $mesh=0; next;}
		if ($submodels && $submodel && $vertex) {
			$vertex = 0;
			next;
		}
		if ($submodels && $submodel) {
			$submodel = 0;
			next;
		}
		if ($submodels) { $submodels = 0; }
		next;
	}
	if ($materials != "0") {
		chomp();
		$junk = $_;
		$junk =~ s/"//g;
		$junk =~ s/^ *//;
		#print "MATERIAL $junk \n";
		$material[$cmat] = $junk;
		$matfile = "$dir/$junk.mat";
		#print "MATFILE $matfile";
		open(MAT, $matfile);
		while(<MAT>) {
			chomp();
			if (/Ambient/) {
				$ambient = $_;
				$ambient =~ s/.*Ambient = \{//;
				$ambient =~ s/\}.*//;
				$ambient =~ s/,//g;
				($a, $b, $c, $d) = split(' ', $ambient);
				$amb[$cmat] = sprintf("%f %f %f %f", $a, $b, $c, $d);
			}
			if (/Diffuse/) {
				$diff = $_;
				$diff =~ s/.*Diffuse = \{//;
				$diff =~ s/\}.*//;
				$diff =~ s/,//g;
				($a, $b, $c, $d) = split(' ', $diff);
				$dif[$cmat] = sprintf("%f %f %f %f", $a, $b, $c, $d);
			}
			if (/Specular/) {
				$spec = $_;
				$spec =~ s/.*Specular = \{//;
				$spec =~ s/\}.*//;
				$spec =~ s/,//g;
				($a, $b, $c, $d) = split(' ', $spec);
				$spe[$cmat] = sprintf("%f %f %f %f", $a, $b, $c, $d);
			}
			if (/Map/) {
				$map = $_;
				$map =~ s/.*Map.*\///;
				$map =~ s/\".*//;
				#print "MAPFILE $dir/$map\n";
				if (/jpg/) {
					system("jpegtopnm $dir/$map | pnmtosgi >$junk.rgb");
				} elsif (/png/) {
					system("pngtopnm $dir/$map | pnmtosgi > $junk.rgb");
				}
			}
		}
		close(MAT);
			
		$cmat++;
	}
	if ($vertex) {
		chomp();
		$junk = $_;
		$junk =~ s/^ *//;
		($x, $y, $z, $nx, $ny, $nz, $u, $v) = split(' ', $junk);
		#print "$cvertex: $x, $y, $z, $nx, $ny, $nz, $u, $v\n";
		$vx[$cvertex] = $x;
		$vy[$cvertex] = $y;
		$vz[$cvertex] = $z;
		$nx[$cvertex] = $nx;
		$ny[$cvertex] = $nx;
		$nz[$cvertex] = $nx;
		$tu[$cvertex] = $u;
		$tv[$cvertex] = $v;
		$cvertex++;
	}
	if ($triangle && $ttype == 1) {
		chomp();
		$junk = $_;    
		$junk =~ s/^ *//;
		#print "$cmesh $cstrip\n";
		$strip[$cmesh] .= $junk;
		#print "XX$junk","XX\n";
	}
	if ($triangle && $ttype == 2) {
		chomp();
		$junk = $_;
		$junk =~ s/^ *//;
		$block[$cmesh][$cblock] = $junk;
		#print "XX$junk","XX\n";
		$cblock++;
	}

}
print "name	\"$dir\"\n";
print "version  \"1.3.1\"\n";

for ($m=0; $m <= $#material; $m++) {
	$in = $material[$m];
	print "begin texture\n";
	print "  name \"$in\"\n";
	print "  image \"$in.rgb\"\n";
	print "end\n";
	print "begin material\n";
	print "  name \"$in\"\n";
	print "  texture \"$in\"\n";
	print;
	if ($amb[$m] ne undef) {
		print "  ambient	$amb[$m]\n";
	}
	if ($dif[$m] ne undef) {
		print "  diffuse	$dif[$m]\n";
	}
	if ($spe[$m] ne undef) {
		print "  specular	$spe[$m]\n";
	}
	print "end\n";
}

for ($i=0; $i <= $cmesh; $i++) {
	print "begin surface\n";
	print "  name \"mesh$i\"\n";
	if ($meshtype[$i] == 2) {
		for ($j = 0; $j < $#{@block[$i]}; $j++) {
			($x, $y, $z) = split(' ', $block[$i][$j]);
			print "#SPANK $block[$i][$j]\n";
			print "  {\n";
			print "    material \"$material[$i]\"\n";
			print "    pos 0 $vx[$x] $vy[$x] $vz[$x]\n";
			print "    nor 0 $nx[$x] $ny[$x] $nz[$x]\n";
			print "    tex 0 $tv[$x] $tu[$x]\n";
			print "    pos 1 $vx[$y] $vy[$y] $vz[$y]\n";
			print "    nor 1 $nx[$y] $ny[$y] $nz[$y]\n";
			print "    tex 1 $tv[$y] $tu[$y]\n";
			print "    pos 2 $vx[$z] $vy[$z] $vz[$z]\n";
			print "    nor 2 $nx[$z] $ny[$z] $nz[$z]\n";
			print "    tex 2 $tv[$z] $tu[$z]\n";
			print "   }\n";
		}
	} elsif ($meshtype[$i] == 1) {
		@foo = split(' ', $strip[$i]);
		for ($j = 0; $j < $#foo - 1; $j++) {
			print "#SPANK $foo[$j] $foo[$j+1] $foo[$j+2] $j\n";
			print "  {\n";
			print "    material \"$material[$i]\"\n";
			print "    pos 0 $vx[$foo[$j]] $vy[$foo[$j]] $vz[$foo[$j]]\n";
			print "    nor 0 $nx[$foo[$j]] $ny[$foo[$j]] $nz[$foo[$j]]\n";
			print "    tex 0 $tv[$foo[$j]] $tu[$foo[$j]]\n";
			print "    pos 1 $vx[$foo[$j+1]] $vy[$foo[$j+1]] $vz[$foo[$j+1]]\n";
			print "    nor 1 $nx[$foo[$j+1]] $ny[$foo[$j+1]] $nz[$foo[$j+1]]\n";
			print "    tex 1 $tv[$foo[$j+1]] $tu[$foo[$j+1]]\n";
			print "    pos 2 $vx[$foo[$j+2]] $vy[$foo[$j+2]] $vz[$foo[$j+2]]\n";
			print "    nor 2 $nx[$foo[$j+2]] $ny[$foo[$j+2]] $nz[$foo[$j+2]]\n";
			print "    tex 2 $tv[$foo[$j+2]] $tu[$foo[$j+2]]\n";
			print "  }\n";
		}
	}
	print "end\n";
}
for ($i=0; $i <= $cmesh; $i++) {
	print "begin node\n";
	print "  index ", $i+1, "\n";
	print "  surface \"mesh$i\"\n";
	print "end\n";
}
print "begin structure\n";
for ($i=0; $i <= $cmesh; $i++) {
	printf("%0.3d\n", $i+1);
}
print "end\n";
