#!/usr/pkg/bin/perl

open(FILE, $ARGV[0]);

$dir = $ARGV[0];
$dir =~ s/\.3d//;

$cmesh=-1;
while(<FILE>) {
	if (/^ *$/) {next;}
	if (/ArkModel/) { $cursubmodel=-1; next;}
	if (/Materials/) {$materials=1; $cmat=0; next;}
	if (/SubModels/) {
	  chomp();
	  $junk = $_;
	  $junk =~ s/.*SubModels //;
	  $nrofsubmodels = $junk;
	  $submodels=1;
	  next;
	}
	if (/Mesh/) {
	  $mesh=1;
	  chomp();
	  $junk = $_;
	  $junk =~ s/.*Mesh //;
	  $cmesh[$cursubmodel] = $junk;
	  next;
	}
	if (/Triangle/) {
		$triangle=1;
		if (/strip/) { $meshtype[$cursubmodel][$cmesh[$cursubmodel]]=1; $ttype=1; $cstrip=0; }
		if (/block/) { $meshtype[$cursubmodel][$cmesh[$cursubmodel]]=2; $ttype=2; $cblock=0; }
		chomp();
		$junk = $_;
		$junk =~ s/.*Triangle [a-z]* //;
		$meshpoints[$cursubmodel][$cmesh[$cursubmodel]] = $junk;
		next;
	}
	if ($submodels == 1 && /SubModel/) {$cursubmodel++; $submodel=1; next;}
	if ($submodel == 1 && /VertexBuffer/) {
	  chomp();
	  $vertex=1;
	  $cvertex=0;
	  $junk = $_;
	  $junk =~ s/.*Buffer //;
	  $junk =~ s/ uv0//;
	  $verts[$cursubmodel][$curvbuf[$cursubmodel]] = $junk;
	  $curvbuf[$cursubmodel]++;
	  next;
	}
	if (/{/) {next;}
	if (/}/) {
		if ($materials) { $materials=0; }
		if ($submodels && $submodel && $mesh && $triangle) {
			$triangle=0;
			next;
		}
		if ($submodels && $submodel && $mesh) { $mesh=0; next;}
		if ($submodels && $submodel && $vertex) {
			$vertex = 0;
			next;
		}
		if ($submodels && $submodel) {
			$submodel = 0;
			next;
		}
		if ($submodels) { $submodels = 0; }
		next;
	}
	if ($materials != "0") {
		chomp();
		$junk = $_;
		$junk =~ s/\"//g;
		$junk =~ s/^ *//;
		#print "MATERIAL $junk \n";
		$material[$cmat] = $junk;
		$matfile = "$dir/$junk.mat";
		#print "MATFILE $matfile";
		open(MAT, $matfile);
		while(<MAT>) {
			chomp();
			if (/Ambient/) {
				$ambient = $_;
				$ambient =~ s/.*Ambient = \{//;
				$ambient =~ s/\}.*//;
				$ambient =~ s/,//g;
				($a, $b, $c, $d) = split(' ', $ambient);
				$amb[$cmat] = sprintf("%f %f %f %f", $a, $b, $c, $d);
			}
			if (/Diffuse/) {
				$diff = $_;
				$diff =~ s/.*Diffuse = \{//;
				$diff =~ s/\}.*//;
				$diff =~ s/,//g;
				($a, $b, $c, $d) = split(' ', $diff);
				$dif[$cmat] = sprintf("%f %f %f %f", $a, $b, $c, $d);
			}
			if (/Specular/) {
				$spec = $_;
				$spec =~ s/.*Specular = \{//;
				$spec =~ s/\}.*//;
				$spec =~ s/,//g;
				($a, $b, $c, $d) = split(' ', $spec);
				$spe[$cmat] = sprintf("%f %f %f %f", $a, $b, $c, $d);
			}
			if (/Map/) {
				$map = $_;
				$map =~ s/.*Map.*\///;
				$map =~ s/\".*//;
				$map[$cmat] = $map;
				#print "MAPFILE $dir/$map\n";
			}
		}
		close(MAT);
			
		$cmat++;
	}
	if ($vertex) {
		chomp();
		$junk = $_;
		$junk =~ s/^ *//;
		($x, $y, $z, $nx, $ny, $nz, $u, $v) = split(' ', $junk);
		#print "$cvertex: $x, $y, $z, $nx, $ny, $nz, $u, $v\n";
		$vx[$cursubmodel][$cvertex] = $x;
		$vy[$cursubmodel][$cvertex] = $y;
		$vz[$cursubmodel][$cvertex] = $z;
		$nx[$cursubmodel][$cvertex] = $nx;
		$ny[$cursubmodel][$cvertex] = $nx;
		$nz[$cursubmodel][$cvertex] = $nx;
		$tu[$cursubmodel][$cvertex] = $u;
		$tv[$cursubmodel][$cvertex] = $v;
		$cvertex++;
	}
	if ($triangle && $ttype == 1) {
		chomp();
		$junk = $_;
		$junk =~ s/^ *//;
		#print "$cmesh $cstrip\n";
		$strip[$cursubmodel][$cmesh[$cursubmodel]] .= $junk;
		#print "XX$junk","XX\n";
	}
	if ($triangle && $ttype == 2) {
		chomp();
		$junk = $_;
		$junk =~ s/^ *//;
		$block[$cursubmodel][$cmesh[$cursubmodel]][$cblock] = $junk;
		#print "XX$junk","XX\n";
		$cblock++;
	}

}
print "<genmodel>\n";
print "<name>$dir</name>\n";
print "<version>1</version>\n";

if ($cmat) {
  print " <materials>\n";
  for ($m=0; $m <= $#material; $m++) {
    $in = $material[$m];
    print "  <material>\n";
    print "   <name>$in</name>\n";
    print "   <image>$map[$m]</image>\n";
    if ($amb[$m] ne undef) {
      print "   <ambient>$amb[$m]</ambient>\n";
    }
    if ($dif[$m] ne undef) {
      print "   <diffuse>$dif[$m]</diffuse>\n";
    }
    if ($spe[$m] ne undef) {
      print "   <specular>$spe[$m]</specular>\n";
    }
    print "  </material>\n";
  }
  print " </materials>\n";
}
for ($l=0; $l < $nrofsubmodels; $l++) {
  print " <surface>\n";
  for ($i=0; $i < $curvbuf[$l]; $i++) {
    print "  <vertexs>\n";
    print "   <verts>$verts[$l][$i]</verts>\n";
    for ($j = 0; $j < $verts[$l][$i]; $j++) {
      print "   <vertex>\n";
      print "    <vertex_x>$vx[$l][$j]</vertex_x>\n";
      print "    <vertex_y>$vy[$l][$j]</vertex_y>\n";
      print "    <vertex_z>$vz[$l][$j]</vertex_z>\n";
      print "    <nor_x>$nx[$l][$j]</nor_x>\n";
      print "    <nor_y>$ny[$l][$j]</nor_y>\n";
      print "    <nor_z>$nz[$l][$j]</nor_z>\n";
      print "    <tex_u>$tu[$l][$j]</tex_u>\n";
      print "    <tex_v>$tv[$l][$j]</tex_v>\n";
      print "   </vertex>\n";
    }
    print "  </vertexs>\n";
  }
  for ($i=0; $i <= $cmesh[$l]; $i++) {
    next if ($meshtype[$l][$i] == 0);
    print "  <triangle>\n";
    print "   <name>mesh$i</name>\n";
    print "   <matnum>$i</matnum>\n";
    print "   <points>$meshpoints[$l][$i]</points>\n";
    if ($meshtype[$l][$i] == 1) {
      print "   <type>strip</type>\n";
      (@foo) = split(' ', $strip[$l][$i]);
      foreach $in (@foo) {
	print "    <face>$in</face>\n";
      }
    } elsif ($meshtype[$l][$i] == 2) {
      print "   <type>block</type>\n";
      for ($k = 0; $k <= $#{@{@block[$l]}[$i]}; $k++) {
	($x, $y, $z) = split(' ', $block[$l][$i][$k]);
	print "    <face>$x $y $z</face>\n";
      }
    }
    print "  </triangle>\n";
    print " </surface>\n";
  }
}
print "</genmodel>\n";
